require "Automaten.rb"

class UTable
  # Arbeitet NUR mit einem DEA
  def initialize(dea)
    # Alle Zustnde in einem Hash speichern und ihnen einen "ordentlichen" Namen
    # nach folgendem Muster zuweissen: K[i] wobei i eine Nummer ist.
    # Eine Tablle ist ein Hash, mit Namen von Zustnden (das ist der Key), denen die bergnge
    # zugewiesen werden. Ein bergang ist ein Key (das Symbol) dem der neue Zustand (Name) als Wert
    # zugewiesen wird
    i = 1;
    @namehs = Hash.new
    @tabelle = Hash.new
    dea.zustaende_each{ |zust|
      @namehs["K#{i}"] = zust.to_s
      @tabelle["K#{i}"] = Hash.new("-")
      i +=1
    }
    
    @uSymbole = Hash.new
    dea.uebergaenge_each{|konf|
      # ede Konfiguration wird aufgespalten und die Information wird wie oben  beschrieben abgelegt
      puts konf.to_s
      @tabelle[@namehs.invert[konf[0].to_s]][konf[1]] = @namehs.invert[konf[2].to_s]
      @uSymbole[konf[1]] = konf[1]
    }
  end
  
  def to_s
    symbole = @uSymbole.values
    maxZlaenge = (@namehs.size).to_s.length+1
    spaltenLaenge = Array.new
    # die Lnge fr jede Spalte berechnen
    symbole.each{|symb|
      (symb.to_s.length > maxZlaenge) ? (spaltenLaenge.push symb.to_s.length) : (spaltenLaenge.push maxZlaenge)
    }
    
    erg = " " *(maxZlaenge+1)+"| "
    spaltenLaenge.each_index{|index|
      erg += (symbole[index].to_s) + " " *(spaltenLaenge[index] - symbole[index].to_s.length + 1)
    }
    erg += "\n"
    erg += "-" *(erg.length-1) + "\n"
    @namehs.each_key{|zName|
      erg += zName + (" " *(maxZlaenge - zName.length + 1)) + "| "
      symbole.each_index{|index|
      folgeZust = (@tabelle[zName])[symbole[index]]
      erg += folgeZust + " " *(spaltenLaenge[index] - folgeZust.length + 1)
      }
      erg +="\n"
    }
    erg 
  end
  
  def save(file)
	 require 'yaml'
	 File.open(file,"w"){|data|
	   YAML.dump(self,data)
	 }
  end
  
  def load(file)
	 require 'yaml'
	 #self = load(File.open(file))
	end
  
end


  a = LR_0.new(Grammar.new("S -> a\n|B\n\nB -> b"))
  puts (UTable.new a).to_s
=begin
  inp = gets.chop

  while inp != ""
    puts "#{inp} = #{eval inp}"
    inp = gets.chop
  end
=end
    
#end