class Elem < Object

  def initialize(wert,nach=nil)
    @wert = wert
    @nach = nach
  end

  def cons(wert)
    Elem.new(wert,self)
  end

  def wert
    @wert
  end

  def nachfolger
    @nach
  end

  def to_s
    return "(#{@wert},nil)" if @nach == nil
    "(#{@wert},#{@nach})"
  end

  def laenge
    return 1 if @nach == nil
    1 + @nach.laenge
  end

end

##########################################

def zeige(t,s)
   puts "#{t} \n  => #{s}"
end

  e1 = Elem.new(16)
  e2 = Elem.new(23,e1)
  e3 = e2.cons(30)
  zeige("e1.to_s",e1.to_s)
  zeige("e2.to_s",e2.to_s)
  zeige("e3.to_s",e3.to_s)
  zeige("e1.wert",e1.wert) 
  zeige("e2.wert",e2.wert) 
  zeige("e3.wert",e3.wert) 
  zeige("e1.nachfolger",e1.nachfolger)  
  zeige("e2.nachfolger",e2.nachfolger)
  zeige("e3.nachfolger",e3.nachfolger)
  zeige("e1.laenge",e1.laenge) 
  zeige("e2.laenge",e2.laenge) 
  zeige("e3.laenge",e3.laenge) 

##########################################

class Liste

  def initialize(elems=nil)
    @elems  = elems
    @laenge = 0 if elems == nil
    @laenge = elems.laenge if elems != nil
    self
  end

  def cons(wert)
    return Liste.new(Elem.new(wert,self.elems)) if @laenge > 0
    Liste.new(Elem.new(wert,nil)) if @laenge == 0
  end

  def elems
    @elems
  end

  def length
    @laenge
  end

  def head
    return "undef" if @laenge == 0
    @elems.wert
  end

  def tail
    return "undef" if @laenge == 0
    Liste.new(@elems.nachfolger)
  end

  def append(liste)
    return Liste.new(liste.elems) if @laenge == 0
    Liste.new(self.tail.append(liste).cons(self.head).elems)
  end

  def to_s
    return "()" if @laenge == 0
    "#{@elems}"
  end

end

##########################################

l1 = Liste.new
l2 = Liste.new(e2)
l3 = Liste.new(e3)

zeige("l1.to_s",l1.to_s) 
zeige("l2.to_s",l2.to_s) 
zeige("l3.to_s",l3.to_s) 
zeige("l1.head",l1.head) 
zeige("l2.head",l2.head) 
zeige("l3.head",l3.head) 
zeige("l1.tail",l1.tail) 
zeige("l2.tail",l2.tail) 
zeige("l3.tail",l3.tail) 
zeige("l1.length",l1.length) 
zeige("l2.length",l2.length) 
zeige("l3.length",l3.length) 

l = l2.append(l3)
  
zeige("l.to_s",l.to_s)  
zeige("l.head",l.head) 
zeige("l.tail",l.tail) 
zeige("l.length",l.length) 